library indie_logo;

import 'package:flutter/material.dart';
import 'package:flutter/painting.dart';

class IndieLogo {
  static Widget indieLogo(
      {required double size,
      double offsetMiddleStick = 0,
      required int milliSeconds}) {
    return FittedBox(
      fit: BoxFit.scaleDown,
      child: AnimatedContainer(
        duration: Duration(milliseconds: milliSeconds),
        width: size,
        height: size,
        // color: Colors.orangeAccent,
        child: FittedBox(
          fit: BoxFit.contain,
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Row(
                children: [
                  _Circle(
                    size: size * 0.1,
                  ),
                  SizedBox(
                    width: size * 0.05,
                  ),
                  _RadiusRectangle(
                    height: size * 0.2,
                    width: size * 0.2,
                    topLeft: size * 0.1,
                  ),
                  SizedBox(
                    width: size * 0.05,
                  ),
                  _RadiusRectangle(
                    height: size * 0.2,
                    width: size * 0.2,
                    topRight: size * 0.1,
                  ),
                ],
              ),
              SizedBox(
                height: size * 0.05,
              ),
              Container(
                width: size * 0.65 + offsetMiddleStick,
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    Container(
                      color: Colors.black,
                      width: size * 0.2,
                      height: size * 0.4,
                    ),
                  ],
                ),
              ),
              SizedBox(
                height: size * 0.05,
              ),
              Row(
                children: [
                  _RadiusRectangle(
                    height: size * 0.2,
                    width: size * 0.2,
                    bottomLeft: size * 0.1,
                  ),
                  SizedBox(
                    width: size * 0.05,
                  ),
                  _RadiusRectangle(
                    height: size * 0.2,
                    width: size * 0.2,
                    bottomRight: size * 0.1,
                  ),
                  SizedBox(
                    width: size * 0.05,
                  ),
                  _Circle(
                    size: size * 0.1,
                  ),
                ],
              )
            ],
          ),
        ),
      ),
    );
  }

  static Widget indieLogoInVertical(
      {required double size, double offsetMiddleStick = 0}) {
    return Container(
      child: Column(
        children: [
          indieLogo(
              size: size,
              offsetMiddleStick: offsetMiddleStick,
              milliSeconds: 200),
          SizedBox(
            height: size * 0.08,
          ),
          Text(
            "IndieSpirit",
            style: TextStyle(fontSize: size * 0.4),
          )
        ],
      ),
    );
  }
}

class _Circle extends StatelessWidget {
  final double size;
  final Color color;

  const _Circle({Key? key, this.size = 18, this.color = Colors.red})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return CircleAvatar(
      backgroundColor: color,
      radius: size,
    );
  }
}

class _RadiusRectangle extends StatelessWidget {
  final double topLeft;
  final double topRight;
  final double bottomLeft;
  final double bottomRight;
  final double height;
  final double width;

  const _RadiusRectangle({
    Key? key,
    this.topLeft = 0,
    this.topRight = 0,
    this.bottomLeft = 0,
    this.bottomRight = 0,
    required this.height,
    required this.width,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return FittedBox(
      fit: BoxFit.contain,
      child: AnimatedContainer(
        duration: const Duration(milliseconds: 300),
        width: width,
        height: height,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.only(
            topLeft: Radius.circular(topLeft),
            topRight: Radius.circular(topRight),
            bottomLeft: Radius.circular(bottomLeft),
            bottomRight: Radius.circular(bottomRight),
          ),
          color: Colors.black,
        ),
      ),
    );
  }
}
